
def read_growing_files(filenames)
  buffer = {}
  handles = {}
  filenames.each_pair do |tag, file|
    handles[tag] = fp = open(file)
    fp.seek(0, IO::SEEK_END)
    buffer[tag] = ""
  end

  while true
    sleep(1)

    handles.each_pair do |tag, fp|
      fsize = File.size(filenames[tag])

      # if file truncated then reopen
      if fsize < fp.pos
        fp.close
        handles[tag] = fp = open(filenames[tag])
	puts "DEBUG: reopening #{tag} file"
      end

      # eof seems to SUX
      if fsize > fp.pos
	buffer[tag] << fp.read(fsize - fp.pos)
	line_list = buffer[tag].split("\n", -1)
	if line_list.size > 1
	  buffer[tag] = line_list.pop
	  yield tag, line_list
	end
      end
    end
  end
end

def real_sleep(expected_sleep)
  done_sleep = 0
  while done_sleep < expected_sleep
    s = sleep(expected_sleep - done_sleep)
    done_sleep += s
  end
end

